diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
index 6a6f1d6de..11dad2ba7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFenceGate.java
@@ -34,7 +34,8 @@ public class BlockLogicFenceGate
 
     @Override
     protected int getMatcherEquivalenceData(final int data) {
-        return data & ~MASK_DIRECTION;
+        assert (data & (MASK_POWERED | MASK_OPEN)) != MASK_POWERED : "fence gate should be opened when powered";
+        return data & ~(MASK_DIRECTION | MASK_POWERED);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
index 53b5267a0..790404ddc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
@@ -397,4 +397,9 @@ public class BlockLogicFire
     public void onEntityCollision(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity entity) {
         entity.activeFireBlock = this.block;
     }
+
+    @Override
+    protected int getMatcherEquivalenceData(int data) {
+        return 0;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
index f6372241c..a6f8badc5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
@@ -15,6 +15,9 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
+
+import java.util.Arrays;
+
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBdc;
@@ -84,4 +87,30 @@ public class BlockLogicFlag extends BlockLogic {
     public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
         return Material.PISTON_DESTROY_ON_PUSH;
     }
+
+    // TODO: pure color comparison instead of dye index comparison
+    @Override
+    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
+        assert world.getBlockType(thisPos) == this.block;
+        if (world.getBlockType(thatPos) != this.block) return false;
+        if (!(world.getTileEntity(thisPos) instanceof TileEntityFlag thisFlag) ||
+            !(world.getTileEntity(thatPos) instanceof TileEntityFlag thatFlag))
+            return false;
+        if (thisFlag.colorHash != thatFlag.colorHash) return false;
+        if (thisFlag.colorHash != ~0) {
+            if (thisFlag.flipped != thatFlag.flipped) return false;
+            if (thisFlag.activeDyes != thatFlag.activeDyes) return false;
+            return Arrays.equals(thisFlag.flagColors, thatFlag.flagColors);
+        } else {
+            assert thatFlag.colorHash == ~0;
+            if (!Arrays.equals(thisFlag.flagColors, thatFlag.flagColors)) return false;
+
+            interface ctx { byte[] EMPTY_FLAG_COLORS = new byte[TileEntityFlag.CANVAS_WIDTH * TileEntityFlag.CANVAS_HEIGHT]; }
+            if (Arrays.equals(thisFlag.flagColors, ctx.EMPTY_FLAG_COLORS)) {
+                assert Arrays.equals(thatFlag.flagColors, ctx.EMPTY_FLAG_COLORS);
+                return true;
+            }
+            return false;
+        }
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
index 378ebe4f0..340eaa8f8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlower.java
@@ -74,7 +74,7 @@ public class BlockLogicFlower
     public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
         this.checkAlive(world, tilePos);
 
-        if (world.getGameRuleValue(GameRules.DO_SEASONAL_GROWTH) && world.getSeasonManager().getCurrentSeason() != null && (!isPermanent(world.getBlockData(tilePos))) && world.getSeasonManager().getCurrentSeason().killFlowers && this.killedByWeather && rand.nextInt(256) == 0) {
+        if (this.killedByWeather && world.getGameRuleValue(GameRules.DO_SEASONAL_GROWTH) && world.getSeasonManager().getCurrentSeason() != null && (!isPermanent(world.getBlockData(tilePos))) && world.getSeasonManager().getCurrentSeason().killFlowers && rand.nextInt(256) == 0) {
             world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
@@ -159,4 +159,9 @@ public class BlockLogicFlower
         }
         return this.canBeBonemealed;
     }
+
+    @Override
+    protected int getMatcherEquivalenceData(int data) {
+        return data & ~((this.killedByWeather) ? MASK_PERMANENT : 0);
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
index ebabd1f2f..f969d4b79 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluid.java
@@ -238,17 +238,8 @@ public abstract class BlockLogicFluid extends BlockLogic {
     }
 
     @Override
-    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
-        final Block<?> bBlock = world.getBlockType(thatPos);
-
-        final int thisMeta = world.getBlockData(thisPos);
-        final int otherMeta = world.getBlockData(thatPos);
-
-        if (Block.hasLogicClass(bBlock, BlockLogicFluid.class)) {
-            return this.material == bBlock.getMaterial() && thisMeta == otherMeta;
-        }
-
-        return false;
+    protected boolean isSameBlockForMatcher(@NotNull Block<?> other) {
+        return other.getLogic() instanceof BlockLogicFluid fluid && fluid.material == this.material;
     }
 
     public static boolean isStillEquivalentToFlowing(Block<?> block1, Block<?> block2) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java
index 67f80c927..e4ebf706e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java
@@ -27,11 +27,9 @@ public class BlockLogicFluidStill extends BlockLogicFluid {
 
     private void setFlowing(@NotNull World world, @NotNull TilePosc tilePos) {
         int meta = world.getBlockData(tilePos);
-        world.noNeighborUpdate = true;
         world.setBlockTypeData(tilePos, this.blockFlowing, meta);
         world.markBlocksDirty(tilePos, tilePos);
         world.scheduleBlockUpdate(tilePos, this.blockFlowing, tickDelay(world, tilePos));
-        world.noNeighborUpdate = false;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java
index 3045ada08..4e6b54adb 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrowthRubyglass.java
@@ -63,7 +63,7 @@ public class BlockLogicGrowthRubyglass extends BlockLogic {
 		if (shape == STATE_BOTTOM) {
 			TilePos topPos = pos.add(dir, new TilePos());
 			int topMeta = world.getBlockData(topPos);
-			if (world.getBlockType(topPos) != this.block || (topMeta & SHAPE_MASK) != STATE_TOP) {
+			if ((topMeta & SHAPE_MASK) != STATE_TOP) {
 				world.setBlockTypeDataNotify(pos, this.block, STATE_BUD | dir.id);
 			}
 		}
@@ -123,6 +123,7 @@ public class BlockLogicGrowthRubyglass extends BlockLogic {
 		return false;
 	}
 
+	// TODO refactor this freak
 	@Override
 	public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
 		TilePos clickedAnchor = tilePos.add(side.direction().opposite(), new TilePos());
@@ -134,26 +135,25 @@ public class BlockLogicGrowthRubyglass extends BlockLogic {
 				TilePos growthPos = clickedAnchor.add(budDir, new TilePos());
 
 				if (!tilePos.equals(growthPos) && world.getBlockType(growthPos) == Blocks.AIR) {
-					world.setBlockTypeNotify(tilePos, Blocks.AIR);
-					world.setBlockData(clickedAnchor, STATE_BOTTOM | (data & DIRECTION_MASK));
-					world.markBlockNeedsUpdate(clickedAnchor);
-					world.setBlockTypeDataNotify(growthPos, this.block, STATE_TOP | (data & DIRECTION_MASK));
-					return;
-				}
-				else if (tilePos.equals(growthPos)) {
-					world.setBlockData(clickedAnchor, STATE_BOTTOM | (data & DIRECTION_MASK));
-					world.markBlockNeedsUpdate(clickedAnchor);
-					world.setBlockTypeDataNotify(tilePos, this.block, STATE_TOP | (data & DIRECTION_MASK));
-					return;
+					world.setBlockType(tilePos, Blocks.AIR);
+					world.markBlockNeedsUpdate(tilePos);
 				}
+				world.setBlockData(clickedAnchor, STATE_BOTTOM | (data & DIRECTION_MASK));
+				world.setBlockTypeData(growthPos, this.block, STATE_TOP | (data & DIRECTION_MASK));
+				world.markBlockNeedsUpdate(clickedAnchor);
+				world.markBlockNeedsUpdate(growthPos);
+				world.notifyBlocksInCapsuleOfNeighborChange(budDir, clickedAnchor, this.block);
+				return;
 			}
 		}
 
+		// TODO this is redundant
 		if (world.isBlockNormalCube(clickedAnchor)) {
 			world.setBlockTypeDataNotify(tilePos, this.block, STATE_BUD | side.direction().id);
 			return;
 		}
 
+		// TODO this is unreachable apparantly
 		for (Side fallback : Side.values()) {
 			TilePos fallbackAnchor = tilePos.add(fallback.direction.opposite(), new TilePos());
 			if (world.isBlockNormalCube(fallbackAnchor)) {
@@ -224,4 +224,9 @@ public class BlockLogicGrowthRubyglass extends BlockLogic {
         }
         return null;
     }
+
+	@Override
+	protected int getMatcherEquivalenceData(int data) {
+		return data & ~DIRECTION_MASK;
+	}
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
index 44a97bf18..5cba540b4 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
@@ -150,4 +150,14 @@ public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
     public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return side.isVertical() ? PartialSupport.INSTANCE.center() : PartialSupport.INSTANCE;
     }
+
+    @Override
+    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
+        assert world.getBlockType(thisPos) == this.block;
+        if (world.getBlockType(thatPos) != this.block) return false;
+        if (!(world.getTileEntity(thisPos) instanceof TileEntityJarButterfly thisJar) ||
+            !(world.getTileEntity(thatPos) instanceof TileEntityJarButterfly thatJar))
+            return false;
+        return thisJar.color.id() == thatJar.color.id();
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java
index d21de68de..b33ba3f0a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJukebox.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityJukebox;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.player.Player;
@@ -50,4 +49,21 @@ public class BlockLogicJukebox extends BlockLogic {
             jukebox.dropContents(world, tilePos.x(), tilePos.y(), tilePos.z());
         }
     }
+
+    @Override
+    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
+        assert world.getBlockType(thisPos) == this.block;
+        if (world.getBlockType(thatPos) != this.block) return false;
+        final int thisData, thatData; {
+            thisData = world.getBlockData(thisPos);
+            thatData = world.getBlockData(thatPos);
+        }
+        if (thisData != thatData) return false;
+        if ((thisData | thatData) == 0) return true;
+
+        if (!(world.getTileEntity(thisPos) instanceof TileEntityJukebox thisJukebox) ||
+            !(world.getTileEntity(thatPos) instanceof TileEntityJukebox thatJukebox))
+            return false;
+        return thisJukebox.record == thatJukebox.record;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
index fb83841cb..1c6969c32 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
@@ -82,9 +82,7 @@ public class BlockLogicLadder extends BlockLogic implements ISupportable {
 
     public @Nullable Side getSideForPlacement(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side clickedSide) {
         TilePosc p = tilePos;
-        if (!world.canPlaceInsideBlock(tilePos)) {
-            p = p.add(clickedSide.direction(), new TilePos());
-        }
+        if (!world.canPlaceInsideBlock(tilePos)) return null;
 
         if (canExistAt(world, p, getMetaForSide(clickedSide))) return clickedSide;
         if (canExistAt(world, p, getMetaForSide(Side.NORTH))) return Side.NORTH;
@@ -97,6 +95,7 @@ public class BlockLogicLadder extends BlockLogic implements ISupportable {
 
     public boolean canExistAt(@NotNull World world, @NotNull TilePosc tilePos, int meta) {
         Side side = getSideFromMeta(meta).opposite();
+        if (!side.isHorizontal()) return false;
         return isSupported(world, tilePos, side);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
index c401bb588..8df6d9034 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
@@ -84,4 +84,9 @@ public class BlockLogicLayerLeaves extends BlockLogicLayerSupportable {
             return meta & ~MASK_PERMANENT;
         }
     }
+
+    @Override
+    protected int getMatcherEquivalenceData(int data) {
+        return super.getMatcherEquivalenceData(data) & ~MASK_PERMANENT;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java
index cb11548b1..df0b4cd1a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java
@@ -203,12 +203,7 @@ public class BlockLogicLeavesBase extends BlockLogic {
     }
 
     @Override
-    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
-        Block<?> bBlock = world.getBlockType(thatPos);
-
-        int thisMeta = world.getBlockData(thisPos) & ~MASK_DECAY_DATA;
-        int otherMeta = world.getBlockData(thatPos) & ~MASK_DECAY_DATA;
-
-        return this.block == bBlock && thisMeta == otherMeta;
+    protected int getMatcherEquivalenceData(int data) {
+        return data & ~MASK_DECAY_DATA;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
index 8c0b4510f..00d53ac83 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMatcher.java
@@ -10,7 +10,6 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.PlacementMode;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Axis;
-import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
@@ -22,7 +21,6 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-import static net.minecraft.core.block.BlockLogicFarmland.isWet;
 import static net.minecraft.core.block.BlockLogicConduit.packEventConduitData;
 
 public class BlockLogicMatcher extends BlockLogicAxisAligned {
@@ -35,12 +33,7 @@ public class BlockLogicMatcher extends BlockLogicAxisAligned {
 
     @Override
     protected boolean isSameBlockForMatcher(final @NotNull Block<?> other) {
-        return other.getLogic() instanceof BlockLogicMatcher;
-    }
-
-    @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return this.isActive ? 1 : 0;
+        return other.getLogic() instanceof BlockLogicMatcher matcher && (this.isActive == matcher.isActive);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
index 6b3582219..6f1777a07 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
@@ -100,4 +100,20 @@ public class BlockLogicMobSpawner extends BlockLogicMobSpawnerDeactivated {
     public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
         return Material.PISTON_CANT_PUSH;
     }
+
+    @Override
+    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
+        assert world.getBlockType(thisPos) == this.block;
+        if (world.getBlockType(thatPos) != this.block) return false;
+        if (!(world.getTileEntity(thisPos) instanceof TileEntityMobSpawner thisSpawner) ||
+            !(world.getTileEntity(thatPos) instanceof TileEntityMobSpawner thatSpawner))
+            return false;
+        final @Nullable String thisId, thatId; {
+            thisId = thisSpawner.getMobId();
+            thatId = thatSpawner.getMobId();
+        }
+        if (thisId == thatId) return true;
+        if (thisId == null || thatId == null) return false;
+        return thisId.equals(thatId);
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
index 44aa5147c..83a4f2f06 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicNote.java
@@ -26,8 +26,22 @@ public class BlockLogicNote extends BlockLogic {
     public static final int MASK_POWERED = 0b1000_0000;
 
     @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & MASK_POWERED;
+    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
+        assert world.getBlockType(thisPos) == this.block;
+        if (world.getBlockType(thatPos) != this.block) return false;
+        final int thisData, thatData; {
+            thisData = world.getBlockData(thisPos);
+            thatData = world.getBlockData(thatPos);
+        }
+        if (thisData != thatData) return false; // We check note as well because it sucks otherwise
+        // // TODO instrument update
+        // final @NotNull Instrument thisInstru, thatInstru; {
+        //     final var query = new TilePos();
+        //     thisInstru = Instrument.getInstrumentFromBlock(world.getBlockType(thisPos.down(query)));
+        //     thatInstru = Instrument.getInstrumentFromBlock(world.getBlockType(thatPos.down(query)));
+        // }
+        // if (thisInstru != thatInstru) return false; // reference eq
+        return true;
     }
 
     public static final byte MAX_NOTE = 24;
@@ -37,7 +51,6 @@ public class BlockLogicNote extends BlockLogic {
         block.withEntity(null);
     }
 
-
     @Override
     public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         final int data = world.getBlockData(tilePos);
@@ -46,6 +59,7 @@ public class BlockLogicNote extends BlockLogic {
         if (isPowered == hasSignal) return;
         world.setBlockData(tilePos, data ^ MASK_POWERED);
         if (hasSignal) triggerNote(world, tilePos);
+        world.notifyBlocksOfNeighborChange(tilePos, this.block);
     }
 
     @Override
@@ -76,6 +90,7 @@ public class BlockLogicNote extends BlockLogic {
         if (isPowered == hasSignal) return;
         world.setBlockData(tilePos, data ^ MASK_POWERED);
         if (hasSignal) triggerNote(world, tilePos);
+        world.notifyBlocksOfNeighborChange(tilePos, this.block);
     }
 
     @Override
@@ -88,6 +103,7 @@ public class BlockLogicNote extends BlockLogic {
         if (!world.isClientSide) {
             changePitch(world, tilePos, player.isSneaking() ? -1 : 1);
             triggerNote(world, tilePos);
+            world.notifyBlocksOfNeighborChange(tilePos, this.block);
         }
         return true;
     }
@@ -96,6 +112,7 @@ public class BlockLogicNote extends BlockLogic {
     public void onActivatorInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
         changePitch(world, tilePos, 1);
         triggerNote(world, tilePos);
+        world.notifyBlocksOfNeighborChange(tilePos, this.block);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
index cca4f6fe7..cb789a486 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
@@ -39,15 +39,27 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
     }
 
     @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        if (this.isPowered) {
-            return data & MASK_POWERED;
+    protected int getMatcherEquivalenceData(int data) {
+        final int dirMask = (this.isPowered) ? MASK_DIRECTION : MASK_DIRECTION | MASK_POWERED;
+        var railDir = RailDirection.getFromMeta(data & dirMask);
+        if (railDir.isStraight()) {
+            railDir = RailDirection.STRAIGHT_NS;
+        } else if (railDir.isSloped()) {
+            railDir = RailDirection.SLOPE_E;
+        } else if (railDir.isCurved()) {
+            assert !this.isPowered;
+            railDir = RailDirection.TURN_ES;
         }
+        data &= ~MASK_DIRECTION;
+        data |= railDir.meta & dirMask;
         return data;
     }
 
     public @NotNull RailDirection getRailDirection(@NotNull WorldSource world, @NotNull TilePosc tilePos) {
-        int meta = world.getBlockData(tilePos);
+        return getRailDirection(world.getBlockData(tilePos));
+    }
+
+    public @NotNull RailDirection getRailDirection(int meta) {
         if (this.isPowered) {
             meta &= MASK_DIRECTION;
         }
@@ -95,10 +107,11 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
 
     @Override
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
-        world.noNeighborUpdate = true; // TODO: this should just be a temporary solution. refactor rails later!
         performRailTurn(world, tilePos, true);
-        world.noNeighborUpdate = false;
         if (this.block == Blocks.RAIL_POWERED) {
+            // TODO: this should just be a temporary solution. refactor rails later!
+            // even hackier than before
+            if (world.getBlockType(tilePos) != this.block) return;
             onNeighborChanged(world, tilePos, this.block);
         }
     }
@@ -110,7 +123,7 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
         }
         int meta = world.getBlockData(tilePos);
         boolean isPoweredFlagSet = (meta & MASK_POWERED) != 0;
-        RailDirection railDirection = getRailDirection(world, tilePos);
+        RailDirection railDirection = getRailDirection(meta);
 
         if (!isSupported(world, tilePos, Side.BOTTOM)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
@@ -143,16 +156,12 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
                     isConnectedPoweredRail1(world, tilePos, false, 0);
 
             boolean changedMeta = false;
-            if (gettingPower && !isPoweredFlagSet) {
-                // Set powered bit
-                world.setBlockData(tilePos, railDirection.meta | MASK_POWERED);
-                changedMeta = true;
-            } else if (!gettingPower && isPoweredFlagSet) {
-                // Remove powered bit
-                world.setBlockData(tilePos, railDirection.meta);
+            if (gettingPower != isPoweredFlagSet) {
+                world.setBlockData(tilePos, (gettingPower) 
+                    ? railDirection.meta | MASK_POWERED
+                    : railDirection.meta);
                 changedMeta = true;
             }
-
             world.markBlockNeedsUpdate(tilePos);
 
             if (changedMeta) {
@@ -166,7 +175,7 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
                     }, this.block);
                 }
             }
-        } else if (block != null && block.isSignalSource() && new Rail(world, tilePos).getAdjacentTracks() == 3) {
+        } else if (block.isSignalSource() && new Rail(world, tilePos).getAdjacentTracks() == 3) {
             performRailTurn(world, tilePos, false);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
index caf9c3020..3accdf548 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
@@ -47,12 +47,12 @@ public class BlockLogicRepeater extends BlockLogic implements ISupportable {
 
     @Override
     protected boolean isSameBlockForMatcher(final @NotNull Block<?> other) {
-        return other.getLogic() instanceof BlockLogicRepeater;
+        return other.getLogic() instanceof BlockLogicRepeater repeater && (this.isRepeaterPowered == repeater.isRepeaterPowered);
     }
 
     @Override
     protected int getMatcherEquivalenceData(final int data) {
-        return (this.isRepeaterPowered ? 0x10 : 0) | (data & MASK_TICK_DELAY);
+        return data & MASK_TICK_DELAY;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
index 47bae33bc..ffd78e7c0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRope.java
@@ -86,7 +86,8 @@ public class BlockLogicRope
         if (heldItem != null && heldItem.getItem() instanceof ItemToolShears) {
             int meta = world.getBlockData(tilePos);
             int forceRope = (~meta) & MASK_ROPE_CONNECT;
-            world.setBlockDataNotify(tilePos, forceRope | (meta & ~MASK_ROPE_CONNECT));
+            world.setBlockData(tilePos, forceRope | (meta & ~MASK_ROPE_CONNECT));
+            world.markBlockNeedsUpdate(tilePos);
             heldItem.damageItem(1, player);
             if (heldItem.stackSize <= 0) {
                 player.destroyCurrentEquippedItem();
@@ -160,4 +161,10 @@ public class BlockLogicRope
     public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
         return new ItemStack[]{new ItemStack(Items.ROPE)};
     }
+
+    @Override
+    protected int getMatcherEquivalenceData(int data) {
+        // return data & ~MASK_ROPE_CONNECT;
+        return 0;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
index ec896c299..204c5b483 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSaplingBase.java
@@ -49,7 +49,7 @@ public abstract class BlockLogicSaplingBase extends BlockLogicFlower implements
         if (world.getBlockLightValue(tilePos.up(queryPos)) >= 9 && rand.nextInt(growthRate) == 0) {
             int l = world.getBlockData(tilePos);
             if ((l & 8) == 0) {
-                world.setBlockDataNotify(tilePos, l | 8);
+                world.setBlockData(tilePos, l | 8);
             } else {
                 growTree(world, tilePos, rand);
             }
@@ -68,4 +68,9 @@ public abstract class BlockLogicSaplingBase extends BlockLogicFlower implements
     }
 
     public abstract void growTree(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random random);
+
+    @Override
+    protected int getMatcherEquivalenceData(int data) {
+        return 0;
+    }
 }
